This zone is where the Expected Credit Loss (ECL) is computed.

![Expected Credit Loss Zone.png](g4HRrcOIOvNP)

We [join](recipe:compute_default_rates_lgd) outputs from the PD model, the LGD model and the EAD projections. LGD is at a state level, whereas PD models are computed for each starting credit status. This three dataset join is handled inside the visual join recipe.

In the next [prepare recipe](recipe:compute_default_rates_lgd_prepared), losses are computed as:

```math
Losses = EAD \times LGD \times PD
```

The ECL is then computed as the discounted losses using a set discount factor.

Two grouping recipes are ligned up successively to summarize the ECL at the agregated level. In the end we have it at a scenario and starting credit status level, but we can also get it at the state level one step before.

Next the model id is injected into the dataset to save the config associated with the run. And a final agregation outputs the report at a scenario, portfolio date and model id level.

Through a [sync](recipe:compute_ecl_reports) that appends instead of overwrites, each run is save in a dataset. This dataset will be used as an input to compute the waterfall between two configurations.

